#include <bits/stdc++.h>

using namespace std;

#define F first
#define S second
#define inf 1000000001
#define infl 1000000000000000001

bool isSorted(const vector<int>& v){
    for (int i = 0; i < (int)v.size()-1; i++){
        if (v[i] > v[i+1]){
            return false;
        }
    }
    return true;
}

vector<int> nxt(const vector<int>& v){
    vector<int> r(v);
    for (int i = 0; i < (int)r.size()-1; i++){
        if (r[i] > r[i+1]){
            swap(r[i], r[i+1]);
        }
    }
    return r;
}

int main(){
    ios_base::sync_with_stdio(false);
    int n, m;
    cin >> n >> m;
    vector<vector<int> > v(m, vector<int>(n));
    for (int i = 0; i < m; i++){
        for (int j = 0; j < n; j++){
            cin >> v[i][j];
        }
    }
    vector<vector<int> > ans;
    vector<bool> used(m, false);
    for (int i = 0; i < m; i++){
        if (isSorted(v[i])){
            ans.push_back(v[i]);
            used[i] = true;
        }
    }
    while ((int)ans.size() < m){
        for (int i = 0; i < m; i++){
            if (!used[i]){
                if (nxt(v[i]) == ans.back()){
                    ans.push_back(v[i]);
                    used[i] = true;
                }
            }
        }
    }
    for (int i = m-1; i >= 0; i--){
        for (int j = 0; j < n; j++){
            cout << ans[i][j] << " ";
        }
        cout << endl;
    }
    return 0;
}






