#include <iostream>
#include <algorithm>
#include <cstdio>

using namespace std;

bool ans[1000000], is_done = false;
int n, k;
int checks[1000000][3];

void check() {
    int fail = 0;
    for (int i = 0; i < k; ++ i) {
        bool answer = false;
        for (int j = checks[i][0] - 1; j < checks[i][1]; ++ j) {
            answer = answer ^ ans[j];
        }
        if (answer != checks[i][2]) {
            fail ++;
        }
    }
    if (fail <= k / 2) {
        for (int i = 0; i < n; ++ i) {
            cout << ans[i];
        }
        cout << endl;
        is_done = true;
    }
}

void rec(int cur_pos) {
    if (cur_pos >= n) {
        check();
        return;
    }
    ans[cur_pos] = false;
    rec(cur_pos + 1);
    if (is_done) {
        return;
    }
    ans[cur_pos] = true;
    rec(cur_pos + 1);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    //freopen("StandardOutput.out", "w", stdout);
    cin >> n >> k;
    for (int i = 0; i < k; ++ i) {
        cin >> checks[i][0];
        cin >> checks[i][1];
        cin >> checks[i][2];
    }
    rec(0);
}
